//.          GPS module for "Virtual Town"project
//.                  Copyright (c) 2005 
//.                                                       
//.  Authors: PAV <AlxPonom@mail.ru>             
//.                                                       
//.  This program is free software under the GPL (>= v2)  
//.  Read the file COPYING coming with project for details 

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Security.Cryptography;
using System.Runtime.InteropServices;
using System.Text;
using GPS;

namespace GEOGraph
{
	using System.Threading;
	using CrdSys;
	using TBase2DVisualizationSOAPFunctionality;


	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class GEOGraph : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button btnShowGPSMonitor;
		public TConfiguration Configuration = new TConfiguration();
		private GPSMonitor GpsMonitor;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label lbStatus;
		private System.Windows.Forms.CheckBox cbEnabled;
		private TVisualizationControlling VisualizationControlling;
	
		public GEOGraph()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//.
			Configuration.Load();
			//.
			GpsMonitor = new GPSMonitor(Configuration.GPSPortName);
			VisualizationControlling = new TVisualizationControlling(Configuration.GEOGraphObjectID,Configuration.idTVisualization,Configuration.idVisualization, GpsMonitor, this, Configuration.UpdateInterval,Configuration.GEOGraphServerIP,Configuration.GEOGraphServerPort,Configuration.ServerURL,Configuration.UserName,Configuration.UserPassword,Configuration.UserID,Configuration.CrdSysID);
			VisualizationControlling.StatusChanged += new TVisualizationControlling.StatusChangedEventHandler(DoOnStatusChanged);
			this.Show();
			VisualizationControlling.Start();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				};
				if (GpsMonitor != null) 
				{
					GpsMonitor.Dispose();
					GpsMonitor = null;
				};
				if (VisualizationControlling != null)
				{
					VisualizationControlling.Destroy();
					VisualizationControlling = null;
				};
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnShowGPSMonitor = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.lbStatus = new System.Windows.Forms.Label();
			this.cbEnabled = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// btnShowGPSMonitor
			// 
			this.btnShowGPSMonitor.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnShowGPSMonitor.Location = new System.Drawing.Point(312, 0);
			this.btnShowGPSMonitor.Name = "btnShowGPSMonitor";
			this.btnShowGPSMonitor.Size = new System.Drawing.Size(64, 32);
			this.btnShowGPSMonitor.TabIndex = 1;
			this.btnShowGPSMonitor.Text = "show monitor";
			this.btnShowGPSMonitor.Click += new System.EventHandler(this.btnShowGPSMonitor_Click);
			// 
			// button1
			// 
			this.button1.Enabled = false;
			this.button1.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.button1.Location = new System.Drawing.Point(24, 0);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(56, 32);
			this.button1.TabIndex = 2;
			this.button1.Text = "status";
			// 
			// lbStatus
			// 
			this.lbStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lbStatus.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lbStatus.Location = new System.Drawing.Point(80, 0);
			this.lbStatus.Name = "lbStatus";
			this.lbStatus.Size = new System.Drawing.Size(232, 32);
			this.lbStatus.TabIndex = 3;
			this.lbStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cbEnabled
			// 
			this.cbEnabled.Checked = true;
			this.cbEnabled.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbEnabled.Location = new System.Drawing.Point(7, 5);
			this.cbEnabled.Name = "cbEnabled";
			this.cbEnabled.Size = new System.Drawing.Size(16, 24);
			this.cbEnabled.TabIndex = 4;
			this.cbEnabled.CheckedChanged += new System.EventHandler(this.cbEnabled_CheckedChanged);
			// 
			// GEOGraph
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(376, 32);
			this.Controls.Add(this.cbEnabled);
			this.Controls.Add(this.lbStatus);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.btnShowGPSMonitor);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Name = "GEOGraph";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "object geo controller";
			this.ResumeLayout(false);

		}
		#endregion

		private void DoOnStatusChanged(string StatusInfo, bool flOk)
		{
			if (flOk)
			{
				lbStatus.BackColor = Color.PaleGreen;
			}
			else
			{
				lbStatus.BackColor = Color.LightCoral;
			};
			lbStatus.Text = StatusInfo;
		}

		private void cbEnabled_CheckedChanged(object sender, System.EventArgs e)
		{
			VisualizationControlling.Enabled = cbEnabled.Checked;
		}

		private void btnShowGPSMonitor_Click(object sender, System.EventArgs e)
		{
			if (!GpsMonitor.Visible) 
			{
				GpsMonitor.Left = this.Left;
				GpsMonitor.Top = this.Top+this.Height;
				GpsMonitor.Width = this.Width;
				GpsMonitor.Show();
				btnShowGPSMonitor.Text = "hide monitor";
			}
			else
			{
				GpsMonitor.Hide();
				btnShowGPSMonitor.Text = "show monitor";
			};
		}

		static void Main() 
		{
			Application.Run(new GEOGraph());
		}
	}

	public struct LogEvent
	{
		public DateTime TimeStamp;
		public double Latitude;
		public double Longitude;
		public double Precision;

		public int Length()
		{
			byte[] TimeStampBA = BitConverter.GetBytes(TimeStamp.Ticks);
			byte[] LatitudeBA = BitConverter.GetBytes(Latitude);
			byte[] LongitudeBA = BitConverter.GetBytes(Longitude);
			byte[] PrecisionBA = BitConverter.GetBytes(Precision);
			return (TimeStampBA.Length+LatitudeBA.Length+LongitudeBA.Length+PrecisionBA.Length);
		}

		public byte[] ToByteArray()
		{
			byte[] TimeStampBA = BitConverter.GetBytes(TimeStamp.Ticks);
			byte[] LatitudeBA = BitConverter.GetBytes(Latitude);
			byte[] LongitudeBA = BitConverter.GetBytes(Longitude);
			byte[] PrecisionBA = BitConverter.GetBytes(Precision);
			byte[] BA = new byte[TimeStampBA.Length+LatitudeBA.Length+LongitudeBA.Length+PrecisionBA.Length];
			int Idx = 0;
			TimeStampBA.CopyTo(BA,Idx); Idx+=TimeStampBA.Length;
			LatitudeBA.CopyTo(BA,Idx); Idx+=LatitudeBA.Length;
			LongitudeBA.CopyTo(BA,Idx); Idx+=LongitudeBA.Length;
			PrecisionBA.CopyTo(BA,Idx); Idx+=PrecisionBA.Length;
			return BA;
		}

		public void FromByteArray(byte[] BA)
		{
			int Idx = 0;
			TimeStamp = new DateTime(BitConverter.ToInt64(BA, Idx)); Idx+=8;
		}
	}

	public class TVisualizationControlling
	{
		public static int ProcessPointsCount = 3;
		public static string LogFolder = "Logs";
		public delegate void StatusChangedEventHandler(string StatusInfo, bool flOk);

		private Thread Processing;
		private bool ProcessingCancelled;
		private Form ControlPanel;
		public int idTVisualization;
		public int idVisualization;
		private GPSMonitor GpsMonitor;
		public int UpdateInterval;
		private string ServerURL;
		private string GEOGraphServerIP;
		private int GEOGraphServerPort;
		private int GEOGraphObjectID;
		private string UserName;
		private string UserPassword;
		private int UserID;
		private int CrdSysID;
		public bool Enabled = true;
		public double X,Y;
		public event StatusChangedEventHandler StatusChanged;
		private int ChangesCount = 0;
		
		public TVisualizationControlling(int pGEOGraphObjectID, int pidTVisualization, int pidVisualization, GPSMonitor pGpsMonitor, Form pControlPanel, int pUpdateInterval, string pGEOGraphServerIP, int pGEOGraphServerPort, string pServerURL, string pUserName, string pUserPassword, int pUserID, int pCrdSysID)
		{	
			GEOGraphServerIP = pGEOGraphServerIP;
			GEOGraphServerPort = pGEOGraphServerPort;
			GEOGraphObjectID = pGEOGraphObjectID;
			idTVisualization = pidTVisualization;
			idVisualization = pidVisualization;
			GpsMonitor = pGpsMonitor;
			ControlPanel = pControlPanel;
			UpdateInterval = pUpdateInterval;
			ServerURL = pServerURL;
			UserName = pUserName;
			UserPassword = pUserPassword;
			UserID = pUserID;
			CrdSysID = pCrdSysID;
			//.
			ThreadStart ThreadDelegate = new ThreadStart(Execute);
			Processing = new Thread(ThreadDelegate);
			ProcessingCancelled = false;
		}

		public void Destroy()
		{
			ProcessingCancelled = true;
			Processing.Join(1000);
		}

		public void Start()
		{
			Processing.Start();
		}

		private void Execute()
		{
			if (GEOGraphServerIP != "")
			{
				try
				{
					FileStream FS = new FileStream(Path.GetDirectoryName(Application.ExecutablePath)+@"\"+LogFolder+@"\"+idTVisualization.ToString()+"_"+idVisualization.ToString()+"__"+DateTime.Now.ToString("yyMMddHHmm")+".dat",FileMode.Create);
					try
					{
						MessageEncryptor MsgEncryptor = new MessageEncryptor(UserPassword);
						try
						{
							while (!ProcessingCancelled) 
							{
								double Lat = 0,Long = 0, Precision = 0;
								bool R;
								//. getting the coordinates
								lock(GpsMonitor)
								{
									R = GpsMonitor.flStatusOk;
									if (R)
									{
										Lat = GpsMonitor.Latitude;
										Long = GpsMonitor.Longitude;
										Precision = GpsMonitor.Precision;
									};
								};
								//. using the coordinates for move to
								if (R && Enabled)
								{
									try
									{
										//. writing log event
										LogEvent Event;
										Event.TimeStamp = DateTime.Now;
										Event.Latitude = Lat;
										Event.Longitude = Long;
										Event.Precision = Precision;
										byte[] BA = Event.ToByteArray();
										FS.Write(BA,0,BA.Length);
										//. move visualization
										GEOGraphMessage Message = new GEOGraphMessage();
										Message.ObjectID = GEOGraphObjectID;
										Message.Latitude = Lat;
										Message.Longitude = Long;
										Message.Precision = Precision;
										byte[] EncryptedMessage = Message.ToEncryptedByteArray(MsgEncryptor);
										//. sending to the server
										IPAddress SrvIP = IPAddress.Parse(GEOGraphServerIP);			
										IPEndPoint SrvIPEndpoint = new IPEndPoint(SrvIP, GEOGraphServerPort);
										Socket socket = new Socket(
											AddressFamily.InterNetwork,
											SocketType.Stream,
											ProtocolType.IP);
										socket.Connect(SrvIPEndpoint);
										try
										{
											socket.Send(EncryptedMessage);
										}
										finally
										{
											socket.Close();
										};
										//.
										ChangesCount++;
										if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"Ok, changes: "+ChangesCount.ToString(),true});
									}								
									catch (Exception E)
									{
										if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"processing error: "+E.Message,false});
									};
								}
								else 
								{
									if (StatusChanged != null)
									{
										if (!R) 
										{
											ControlPanel.Invoke(StatusChanged, new object[2] {"GPS receiver in offline",false});
										}
										else
										{
											if (!Enabled) 
											{
												ControlPanel.Invoke(StatusChanged, new object[2] {"controlling disabled",false});
											};
										};
									}
								}
								//. sleeping ...
								for (int J = 0; J < UpdateInterval; J++)
								{
									//. sleep 1 second
									for (int I = 0; I < 9; I++)
									{ 
										Thread.Sleep(100); 
										if (ProcessingCancelled) return; //. ->
									};
								};
							};
						}
						finally
						{
							MsgEncryptor.Destroy();
						};
					}
					finally
					{
						FS.Close();
					};
				}
				catch (Exception E)
				{
					if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"fatal error: "+E.Message,false});
				};
			}
			else
			{
				try
				{
					FileStream FS = new FileStream(Path.GetDirectoryName(Application.ExecutablePath)+@"\"+LogFolder+@"\"+idTVisualization.ToString()+"_"+idVisualization.ToString()+"__"+DateTime.Now.ToString("yyMMddHHmm")+".dat",FileMode.Create);
					try
					{
						MessageEncryptor MsgEncryptor = new MessageEncryptor(UserPassword);
						try
						{
							TCrdSysConvertor CrdSysConvertor = new TCrdSysConvertor(ServerURL,UserName,UserPassword,CrdSysID,ProcessPointsCount);
							bool flProcessingPointsLoaded = false;
							while (!ProcessingCancelled) 
							{
								double Lat = 0,Long = 0, Precision = 0;
								bool R;
								//. getting the coordinates
								lock(GpsMonitor)
								{
									R = GpsMonitor.flStatusOk;
									if (R)
									{
										Lat = GpsMonitor.Latitude;
										Long = GpsMonitor.Longitude;
										Precision = GpsMonitor.Precision;
									};
								};
								//. using the coordinates for move to
								if (R && Enabled)
								{
									try
									{
										if (!flProcessingPointsLoaded) 
										{
											flProcessingPointsLoaded = CrdSysConvertor.GeoToXY_LoadPoints(Lat,Long);
										};
										//.
										if (flProcessingPointsLoaded) 
										{
											CrdSysConvertor.ConvertGeoToXY(Lat,Long, out X, out Y);
											//. writing log event
											LogEvent Event;
											Event.TimeStamp = DateTime.Now;
											Event.Latitude = Lat;
											Event.Longitude = Long;
											Event.Precision = Precision;
											byte[] BA = Event.ToByteArray();
											FS.Write(BA,0,BA.Length);
											//. move visualization
											CrdSysConvertor.ConvertGeoToXY(Event.Latitude,Event.Longitude, out X, out Y);
											ITBase2DVisualizationSOAPFunctionalityService VF = new ITBase2DVisualizationSOAPFunctionalityService(ServerURL);
											VF.SetPosition(UserName,UserPassword,idTVisualization,idVisualization, X,Y,0);
											//.
											ChangesCount++;
											if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"Ok, changes: "+ChangesCount.ToString(),true});
										}
										else
										{
											if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"processing points not loaded",false});
										};
									}
									catch (Exception E)
									{
										if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"processing error: "+E.Message,false});
									};
								}
								else 
								{
									if (StatusChanged != null)
									{
										if (!R) 
										{
											ControlPanel.Invoke(StatusChanged, new object[2] {"GPS receiver in offline",false});
										}
										else
										{
											if (!Enabled) 
											{
												ControlPanel.Invoke(StatusChanged, new object[2] {"controlling disabled",false});
											};
										};
									}
								}
								//. sleeping ...
								for (int J = 0; J < UpdateInterval; J++)
								{
									//. sleep 1 second
									for (int I = 0; I < 9; I++)
									{ 
										Thread.Sleep(100); 
										if (ProcessingCancelled) return; //. ->
									};
								};
							};
						}
						finally
						{
							MsgEncryptor.Destroy();
						};
					}
					finally
					{
						FS.Close();
					};
				}
				catch (Exception E)
				{
					if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"fatal error: "+E.Message,false});
				};
			};
		}
	}

	public class TVisualizationControlPlayback
	{
		public static int ProcessPointsCount = 3;
		public static string LogFolder = "Logs";
		public delegate void StatusChangedEventHandler(string StatusInfo, bool flOk);

		private Thread Processing;
		private bool ProcessingCancelled;
		private Form ControlPanel;
		public int idTVisualization;
		public int idVisualization;
		private string DataFileName;
		private string ServerURL;
		private string UserName;
		private string UserPassword;
		private int CrdSysID;
		public double X,Y;
		public event StatusChangedEventHandler StatusChanged;
		private int ChangesCount = 0;
		
		public TVisualizationControlPlayback(int pidTVisualization, int pidVisualization, string pDataFileName, Form pControlPanel, string pServerURL, string pUserName, string pUserPassword, int pCrdSysID)
		{	
			idTVisualization = pidTVisualization;
			idVisualization = pidVisualization;
			DataFileName = pDataFileName;
			ControlPanel = pControlPanel;
			ServerURL = pServerURL;
			UserName = pUserName;
			UserPassword = pUserPassword;
			CrdSysID = pCrdSysID;
			//.
			ThreadStart ThreadDelegate = new ThreadStart(Execute);
			Processing = new Thread(ThreadDelegate);
			ProcessingCancelled = false;
		}

		public void Destroy()
		{
			ProcessingCancelled = true;
			Processing.Join(1000);
		}

		public void Start()
		{
			Processing.Start();
		}

		private void Execute()
		{
			int UpdateInterval = 1;
			TCrdSysConvertor CrdSysConvertor = new TCrdSysConvertor(ServerURL,UserName,UserPassword,CrdSysID,ProcessPointsCount);
			bool flProcessingPointsLoaded = false;
			try
			{
				FileStream FS = new FileStream(DataFileName,FileMode.Open);
				try
				{
					while (!ProcessingCancelled) 
					{
						try
						{
							//. load log item
							LogEvent Event = new LogEvent();
							byte[] BA = new byte[Event.Length()];
							FS.Read(BA,0,BA.Length);
							Event.FromByteArray(BA);
							//.
							if (!flProcessingPointsLoaded) 
							{
								flProcessingPointsLoaded = CrdSysConvertor.GeoToXY_LoadPoints(Event.Latitude,Event.Longitude);
							};
							//.
							if (flProcessingPointsLoaded) 
							{
								CrdSysConvertor.ConvertGeoToXY(Event.Latitude,Event.Longitude, out X, out Y);
								//. move visualization
								ITBase2DVisualizationSOAPFunctionalityService VF = new ITBase2DVisualizationSOAPFunctionalityService(ServerURL);
								VF.SetPosition(UserName,UserPassword,idTVisualization,idVisualization, X,Y,0);
								ChangesCount++;
								if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"Ok, changes: "+ChangesCount.ToString(),true});
							}
							else
							{
								if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"processing points not loaded",false});
							};
						}
						catch (Exception E)
						{
							if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"processing error: "+E.Message,false});
						};
						//. sleeping ...
						for (int J = 0; J < UpdateInterval; J++)
						{
							//. sleep 1 second
							for (int I = 0; I < 9; I++)
							{ 
								Thread.Sleep(100); 
								if (ProcessingCancelled) return; //. ->
							};
						};
					};
				}
				finally
				{
					FS.Close();
				};
			}
			catch (Exception E)
			{
				if (StatusChanged != null) ControlPanel.Invoke(StatusChanged, new object[2] {"fatal error: "+E.Message,false});
			};
		}
	}

	public struct TConfiguration
	{
		public string GPSPortName;
		public string ServerURL;
		public string GEOGraphServerIP;
		public int GEOGraphServerPort;
		public int GEOGraphObjectID;
		public string UserName;
		public int UserID;
		public string UserPassword;
		public int idTVisualization;
		public int idVisualization;
		public int CrdSysID;
		public int UpdateInterval;

		public void Load()
		{
			IniFile ini = new IniFile(Path.GetDirectoryName(Application.ExecutablePath)+@"\Config.ini");
			//. GPS port
			GPSPortName = ini.IniReadValue("GPS","ReceiverPort");
			//. SERVER
			ServerURL = ini.IniReadValue("SERVER","ServerURL");
			GEOGraphServerIP = ini.IniReadValue("SERVER","GEOGraphServerIP");
			if (GEOGraphServerIP != "")
			{
				GEOGraphServerPort = Convert.ToInt32(ini.IniReadValue("SERVER","GEOGraphServerPort"));
				GEOGraphObjectID = Convert.ToInt32(ini.IniReadValue("SERVER","GEOGraphObjectID"));
			};
			UserName = ini.IniReadValue("SERVER","UserName");
			UserID = Convert.ToInt32(ini.IniReadValue("SERVER","UserID"));
			UserPassword = ini.IniReadValue("SERVER","UserPassword");
			CrdSysID = Convert.ToInt32(ini.IniReadValue("SERVER","CrdSysID"));
			//. VISUALIZATION
			idTVisualization = Convert.ToInt32(ini.IniReadValue("VISUALIZATION","TypeID"));
			idVisualization = Convert.ToInt32(ini.IniReadValue("VISUALIZATION","ID"));
			//. UPDATING
			UpdateInterval = Convert.ToInt32(ini.IniReadValue("UPDATING","Interval"));
		}
	}

	public struct GEOGraphMessage
	{
		public byte Type;
		public byte Version;
		public int ObjectID;
		public double Latitude;
		public double Longitude;
		public double Precision;

		public byte[] ToEncryptedByteArray(MessageEncryptor Encryptor)
		{
			Type = 1;
			Version = 1;
			//.
			byte[] BA = new byte[3*8];
			int Idx = 0;
			BitConverter.GetBytes(Latitude).CopyTo(BA,Idx);         Idx+=8;
			BitConverter.GetBytes(Longitude).CopyTo(BA,Idx);        Idx+=8;
			BitConverter.GetBytes(Precision).CopyTo(BA,Idx);        
			BA = Encryptor.Encrypt(BA);
			byte[] Result = new byte[1+1+4+BA.Length];
			Idx = 0;
			BitConverter.GetBytes(Type).CopyTo(Result,Idx);    Idx+=1;
			BitConverter.GetBytes(Version).CopyTo(Result,Idx); Idx+=1;
			BitConverter.GetBytes(ObjectID).CopyTo(Result,Idx);  Idx+=4;
			BA.CopyTo(Result,Idx);
			return Result;
		}
	}

	public class MessageEncryptor
	{
		private ICryptoTransform Encryptor;

		public MessageEncryptor(string pKeyString)
		{
			System.Text.Encoding encoding = System.Text.Encoding.ASCII;
			byte[] KeyStringBytes = encoding.GetBytes(pKeyString);
			byte[] MD5Hash;
			using (MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider())
			{
				MD5Hash = md5.ComputeHash(KeyStringBytes);	
			};
			using (RC2CryptoServiceProvider rc2 = new RC2CryptoServiceProvider())
			{
				rc2.IV = new byte[8] {255,1,128,2,64,4,32,8};
				rc2.Key = MD5Hash;
				Encryptor = rc2.CreateEncryptor();
			};
		}

		public void Destroy()
		{
			Encryptor.Dispose();
		}

		public byte[] Encrypt(byte[] Message)
		{
			MemoryStream RS = new MemoryStream(Message.Length);
			try
			{
				CryptoStream EncryptiongStream = new CryptoStream(RS,Encryptor,CryptoStreamMode.Write);
				try
				{
					EncryptiongStream.Write(Message,0,Message.Length);
				}
				finally
				{
					EncryptiongStream.Close();
				};
				return RS.ToArray();
			}
			finally
			{
				RS.Close();
			};
		}
	}

	public class IniFile
	{
		public string path;
		[DllImport("kernel32")]
		private static extern long WritePrivateProfileString(string section, string key,string val,string filePath);
		[DllImport("kernel32")]		
		private static extern int GetPrivateProfileString(string section, string key,string def, StringBuilder retVal,int size,string filePath);
		public IniFile(string INIPath)
		{
			path = INIPath;
		}
		public void IniWriteValue(string Section,string Key,string Value)
		{
			WritePrivateProfileString(Section,Key,Value,this.path);
		}
        
		public string IniReadValue(string Section,string Key)
		{
			StringBuilder temp = new StringBuilder(255);
			int i = GetPrivateProfileString(Section,Key,"",temp, 
				255, this.path);
			return temp.ToString();

		}
	}
}
