//.          GPS module for "Virtual Town"project
//.                  Copyright (c) 2005 
//.                                                       
//.  Authors: PAV <AlxPonom@mail.ru>             
//.                                                       
//.  This program is free software under the GPL (>= v2)  
//.  Read the file COPYING coming with project for details 

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GPS
{

	/// <summary>
	/// GPSMonitor
	/// </summary>
	public class GPSMonitor : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox tbLatitude;
		private System.Windows.Forms.TextBox tbLongitude;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox tbSpeed;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Panel pnlFixObtained;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Timer Updater;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.TextBox tbTime;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Panel pnlPrecision;
		private double pnlPrecision_DOP = -1;
		private double pnlPrecision_MaxDOP = 8.0;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TextBox tbSatellitesInView;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Panel pnlLinkStatus;
		private System.Windows.Forms.Panel panel2;
		private GPSReading GpsReading = null;
		public bool flStatusOk = false;
		public double Precision;
		public DateTime LocalTime;
		public double Latitude;
		public double Longitude;
		public double Speed;
		public double Bearing;
		private System.Windows.Forms.TextBox tbBearing;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;

		public GPSMonitor(string GPSPortName)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//.
			GpsReading = new GPSReading(GPSPortName);
			Updater.Interval = GpsReading.UpdateInterval;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				};
				if (GpsReading != null)
				{
					GpsReading.Terminate();
					GpsReading = null;
				};
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.label1 = new System.Windows.Forms.Label();
			this.tbLatitude = new System.Windows.Forms.TextBox();
			this.tbLongitude = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.tbSpeed = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.pnlFixObtained = new System.Windows.Forms.Panel();
			this.label4 = new System.Windows.Forms.Label();
			this.Updater = new System.Windows.Forms.Timer(this.components);
			this.tbTime = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.pnlPrecision = new System.Windows.Forms.Panel();
			this.panel1 = new System.Windows.Forms.Panel();
			this.tbSatellitesInView = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.pnlLinkStatus = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.tbBearing = new System.Windows.Forms.TextBox();
			this.label8 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label1.Location = new System.Drawing.Point(8, 44);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Latitude";
			// 
			// tbLatitude
			// 
			this.tbLatitude.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbLatitude.Location = new System.Drawing.Point(64, 40);
			this.tbLatitude.Name = "tbLatitude";
			this.tbLatitude.ReadOnly = true;
			this.tbLatitude.Size = new System.Drawing.Size(120, 24);
			this.tbLatitude.TabIndex = 2;
			this.tbLatitude.Text = "";
			// 
			// tbLongitude
			// 
			this.tbLongitude.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbLongitude.Location = new System.Drawing.Point(256, 40);
			this.tbLongitude.Name = "tbLongitude";
			this.tbLongitude.ReadOnly = true;
			this.tbLongitude.Size = new System.Drawing.Size(112, 24);
			this.tbLongitude.TabIndex = 3;
			this.tbLongitude.Text = "";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label2.Location = new System.Drawing.Point(192, 43);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "Longitude";
			// 
			// tbSpeed
			// 
			this.tbSpeed.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbSpeed.Location = new System.Drawing.Point(56, 72);
			this.tbSpeed.Name = "tbSpeed";
			this.tbSpeed.ReadOnly = true;
			this.tbSpeed.Size = new System.Drawing.Size(64, 24);
			this.tbSpeed.TabIndex = 4;
			this.tbSpeed.Text = "";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label3.Location = new System.Drawing.Point(8, 75);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(72, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Speed";
			// 
			// pnlFixObtained
			// 
			this.pnlFixObtained.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlFixObtained.Location = new System.Drawing.Point(344, 3);
			this.pnlFixObtained.Name = "pnlFixObtained";
			this.pnlFixObtained.Size = new System.Drawing.Size(24, 24);
			this.pnlFixObtained.TabIndex = 6;
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label4.Location = new System.Drawing.Point(252, 8);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(104, 16);
			this.label4.TabIndex = 7;
			this.label4.Text = "satellites visible";
			// 
			// Updater
			// 
			this.Updater.Enabled = true;
			this.Updater.Interval = 3000;
			this.Updater.Tick += new System.EventHandler(this.Updater_Tick);
			// 
			// tbTime
			// 
			this.tbTime.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbTime.Location = new System.Drawing.Point(304, 72);
			this.tbTime.Name = "tbTime";
			this.tbTime.ReadOnly = true;
			this.tbTime.Size = new System.Drawing.Size(64, 24);
			this.tbTime.TabIndex = 1;
			this.tbTime.Text = "";
			this.tbTime.TextChanged += new System.EventHandler(this.tbTime_TextChanged);
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label5.Location = new System.Drawing.Point(264, 75);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(56, 16);
			this.label5.TabIndex = 8;
			this.label5.Text = "Time";
			// 
			// pnlPrecision
			// 
			this.pnlPrecision.BackColor = System.Drawing.SystemColors.Control;
			this.pnlPrecision.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlPrecision.ForeColor = System.Drawing.SystemColors.ControlText;
			this.pnlPrecision.Location = new System.Drawing.Point(304, 128);
			this.pnlPrecision.Name = "pnlPrecision";
			this.pnlPrecision.Size = new System.Drawing.Size(64, 64);
			this.pnlPrecision.TabIndex = 10;
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel1.Location = new System.Drawing.Point(8, 31);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(360, 2);
			this.panel1.TabIndex = 11;
			// 
			// tbSatellitesInView
			// 
			this.tbSatellitesInView.BackColor = System.Drawing.SystemColors.Control;
			this.tbSatellitesInView.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbSatellitesInView.Location = new System.Drawing.Point(8, 128);
			this.tbSatellitesInView.Multiline = true;
			this.tbSatellitesInView.Name = "tbSatellitesInView";
			this.tbSatellitesInView.Size = new System.Drawing.Size(288, 64);
			this.tbSatellitesInView.TabIndex = 5;
			this.tbSatellitesInView.Text = "";
			this.tbSatellitesInView.WordWrap = false;
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label6.Location = new System.Drawing.Point(8, 112);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(144, 16);
			this.label6.TabIndex = 13;
			this.label6.Text = "Satellites in view";
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label7.Location = new System.Drawing.Point(33, 8);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(151, 16);
			this.label7.TabIndex = 15;
			this.label7.Text = "Link and receiver status";
			// 
			// pnlLinkStatus
			// 
			this.pnlLinkStatus.BackColor = System.Drawing.Color.Red;
			this.pnlLinkStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlLinkStatus.Location = new System.Drawing.Point(8, 3);
			this.pnlLinkStatus.Name = "pnlLinkStatus";
			this.pnlLinkStatus.Size = new System.Drawing.Size(24, 24);
			this.pnlLinkStatus.TabIndex = 14;
			// 
			// panel2
			// 
			this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel2.Location = new System.Drawing.Point(8, 104);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(360, 2);
			this.panel2.TabIndex = 16;
			// 
			// tbBearing
			// 
			this.tbBearing.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbBearing.Location = new System.Drawing.Point(184, 73);
			this.tbBearing.Name = "tbBearing";
			this.tbBearing.ReadOnly = true;
			this.tbBearing.Size = new System.Drawing.Size(72, 24);
			this.tbBearing.TabIndex = 18;
			this.tbBearing.Text = "";
			// 
			// label8
			// 
			this.label8.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label8.Location = new System.Drawing.Point(128, 76);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(72, 16);
			this.label8.TabIndex = 17;
			this.label8.Text = "Bearing ";
			// 
			// label9
			// 
			this.label9.Font = new System.Drawing.Font("Tahoma", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label9.Location = new System.Drawing.Point(304, 112);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(64, 16);
			this.label9.TabIndex = 19;
			this.label9.Text = "Precision";
			// 
			// GPSMonitor
			// 
			this.AutoScale = false;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(376, 203);
			this.ControlBox = false;
			this.Controls.Add(this.label9);
			this.Controls.Add(this.tbBearing);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.pnlFixObtained);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.pnlLinkStatus);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.tbSatellitesInView);
			this.Controls.Add(this.tbTime);
			this.Controls.Add(this.tbSpeed);
			this.Controls.Add(this.tbLongitude);
			this.Controls.Add(this.tbLatitude);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.pnlPrecision);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "GPSMonitor";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "GPSMonitor";
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.GPSMonitor_Paint);
			this.ResumeLayout(false);

		}
		#endregion

		private void UpdateDATA()
		{
			lock(this)
			{
				flStatusOk = false;
				if (GpsReading.LinkErrors() == 0)
				{
					pnlLinkStatus.BackColor = Color.Green;
				}
				else
				{
					pnlLinkStatus.BackColor = Color.Red;
					return; //. ->
				};
				double HDOP,VDOP,PDOP;
				string SatellitesInfo;
				//.
				GpsReading.GerParameters(out HDOP, out VDOP, out PDOP, out SatellitesInfo);
				Precision = HDOP*6.0;
				pnlPrecision_DOP = HDOP;
				tbSatellitesInView.Text = SatellitesInfo;
				pnlPrecision_Update();
				//.
				if (GpsReading.IsFixObtained())
				{
					double Lat,Long,Spd,Brng;
					System.DateTime LT;
					//.
					GpsReading.GetDATA(out Lat,out Long,out Spd, out Brng, out LT);
					//.
					LocalTime = LT;
					Latitude = Lat;
					Longitude = Long;
					Speed = Spd;
					Bearing = Brng;
					flStatusOk = true;
					//.
					pnlFixObtained.BackColor = Color.Green;
					tbTime.Text = LocalTime.ToShortTimeString();
					int D,M;
					double S;
					//. latitude
					D = (int)(Latitude);
					M = (int)(60*(Latitude-D));
					S = (60*(60*(Latitude-D)-M));
					tbLatitude.Text = D.ToString()+""+M.ToString()+"'"+S.ToString("00.###")+"''";
					//. longitude
					D = (int)(Longitude);
					M = (int)(60*(Longitude-D));
					S = (60*(60*(Longitude-D)-M));
					tbLongitude.Text = D.ToString()+""+M.ToString()+"'"+S.ToString("00.###")+"''";
					//.
					tbSpeed.Text = Speed.ToString();
					tbBearing.Text = Bearing.ToString();
				}
				else
				{
					pnlFixObtained.BackColor = Color.Red;
				};
			};
		}

		private void pnlPrecision_Update()
		{
			Bitmap BMP = new Bitmap(pnlPrecision.Width,pnlPrecision.Height);
			Graphics g = Graphics.FromImage(BMP);
			try
			{
				Brush brush = new SolidBrush(SystemColors.Control);
				try
				{
					g.FillRectangle(brush,0,0,pnlPrecision.Width,pnlPrecision.Height);
				}
				finally
				{
					brush.Dispose();
				};
				if ((pnlPrecision_DOP == -1) || (pnlPrecision_DOP == 0)) return; //. ->
				double R = pnlPrecision.Width/2.0*(pnlPrecision_DOP/pnlPrecision_MaxDOP);
				int CenterOfs = (int)(pnlPrecision.Width/2.0);
				//.
				Color color;
				if (pnlPrecision_DOP < 7) color = Color.Green;  else				
				if (pnlPrecision_DOP < 9) color = Color.Yellow; else	color = Color.Red;
				//.
				brush = new SolidBrush(color);
				try
				{
					g.FillEllipse(brush,(int)(CenterOfs-R),(int)(CenterOfs-R),(int)(2*R),(int)(2*R));
				}
				finally
				{
					brush.Dispose();
				};
				Font font = new Font("Tahoma", 10, FontStyle.Bold);
				try
				{
					string S = ((double)(pnlPrecision_DOP*6.0)).ToString()+" m";
					SizeF Sz = g.MeasureString(S,font);
					g.DrawString(S,font,Brushes.Black,CenterOfs-Sz.Width/2,CenterOfs-Sz.Height/2);
				}
				finally
				{
					font.Dispose();
				};
			}
			finally
			{
				g.Dispose();
			};
			g = pnlPrecision.CreateGraphics();
			try
			{
				g.DrawImage(BMP,0,0);
			}
			finally
			{
				g.Dispose();
			};
		}

		private void Updater_Tick(object sender, System.EventArgs e)
		{
			UpdateDATA();
		}

		private void GPSMonitor_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			pnlPrecision_Update();
		}

		private void tbTime_TextChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
